// printf support
#include <stdio.h>

// simkin includes required for this file
#include "skInterpreter.h"
#include "skRValue.h"
#include "skRValueArray.h"

// my scripted object include
#include "ScriptedObject.h"

int main(void)
{

	printf("<program> begin scripting test\n");

	// create and set interpreter
	skInterpreter::setInterpreter(new skInterpreter);

	// create user derived scriptable object and associate it with the script
	ScriptedObject my_object(skString("test.s"), 3);

	// we need some parameters and a return value
	skRValueArray args(2);
	skRValue ret;

	// give it some parameters
	args.insert(skString("hi from script!"), 0);
	args.insert(skRValue(5), 1);

	try
	{
		// call the function in the script
		// we could do this from within our object as well
		my_object.method(skString("ScriptFunc"), args, ret);
	}
	catch (...)
	{
		// an error occured.  could be missing symbols in the script.
		printf("<program> exception!\n");
	}

	// remember to delete the interpreter at the end of everything
	delete skInterpreter::getInterpreter();
	skInterpreter::setInterpreter(0);

	printf("<program> end scripting test\n");

	return 0;

}
